import axios from 'axios'

const apiServer = axios.create({
  baseURL: `/api/`,
  withCredentials: false,
  headers: {
    Accept: 'text/plain',
    'Content-Type': 'application/json',
    // set the Authorization header using the access token
  },
})

export default {
 
  accountCheck(mobile) {
    return apiServer.post(`Account/Check`, {
      mobile: mobile,
    })
  },
  login(loginData) {
    return apiServer.post(`Account/Login`, {
      mobile: loginData.login.mobile,
      password: loginData.login.password,
    })
  },
  forgetPassword(mobile) {
    return apiServer.post(`Account/ForgetPassword`, {
      mobile: mobile,
    })
  },
  AddAddress(addressData){
    return apiServer.post(`Account/AddressAdd`, {
      addressData
    })
  }

  // userprofile() {
  //   return apiServer.get(`Account/UserProfile`)
  // },

  //   getProductLists(groupID) {
  //     return apiServer.get(
  //       `Products/List?page=1&pageCount=3&order=0&onlyExist=false&groupID=${groupID}`
  //     )
  //   },
  //   getListProductsGroupbyParnet() {
  //     return apiServer.post(`Base/ListProductGroupbyParnetId`,{
  //       parentId: 0,
  //     })
  //   },
}
