import ProductService from '@/services/ProductService.js'
import axios from 'axios'

export const state = () => ({
  ListShipping: [],
  ListDesliverySchedule: [],
  ListShippingMethod: [],
  UserAddressList: [],
  msg: '',

  // count: 0,
  // showAddToCard: false,
})
export const getters = {
  GetListShipping(state) {
    return state.ListShipping
  },
  GetListDesliverySchedule(state) {
    return state.ListDesliverySchedule
  },
  GetListShippingMethod(state) {
    return state.ListShippingMethod
  },
  GetUserAddressList(state) {
    return state.UserAddressList
  },
  GetMsg(state) {
    return state.msg
  },
}
export const mutations = {
  SET_LIST_SHIPPING(state, ListShipping) {
    state.ListShipping = ListShipping
  },
  SET_LIST_DESLIVARY_SCHEDULE(state, ListDesliverySchedule) {
    state.ListDesliverySchedule = ListDesliverySchedule
  },
  SET_LIST_SHIPPING_METHOD(state, ListShippingMethod) {
    state.ListShippingMethod = ListShippingMethod
  },
  SET_USER_ADDRESS_LIST(state, UserAddressList) {
    state.UserAddressList = UserAddressList
  },
  SET_EDIT_USER_ADDRESS_LIST(state, Data) {
    const address = state.UserAddressList.find(
      (address) => address.id == Data.id
    )
    console.log('address', address, Data.id)
    address.mobile = Data.mobile
    address.name = Data.name
    address.address = Data.address
  },
  SET_MSG(state, msg) {
    console.log('msg', msg)

    state.msg = msg
  },
}
export const actions = {
  async FetchListShipping({ state, commit }) {
    var config = {
      method: 'GET',
      url: '/api/Base/ListShippingMethod',
      headers: {
        Accept: 'text/plain',
        'Content-Type': 'application/json',
        Authorization: 'Bearer ' + this.$cookies.get('2sote_Auth_Token'),
      },
    }
    try {
      await axios(config).then((response) => {
        console.log('FetchListShipping', response)
        if (response.status == 200 && response.status !== 401) {
          commit('SET_LIST_SHIPPING', response.data.data)
        }
      })
    } catch (err) {}
  },

  async FetchListDesliverySchedule({ state, commit }) {
    var config = {
      method: 'GET',
      url: '/api/Base/ListDesliverySchedule',
      headers: {
        Accept: 'text/plain',
        'Content-Type': 'application/json',
        Authorization: 'Bearer ' + this.$cookies.get('2sote_Auth_Token'),
      },
    }
    try {
      await axios(config).then((response) => {
        console.log('FetchListDesliverySchedule', response)
        commit('SET_LIST_DESLIVARY_SCHEDULE', response.data.data)
      })
    } catch (err) {}
  },

  async FetchListShippingMethod({ state, commit }) {
    var config = {
      method: 'GET',
      url: '/api/Base/ListShippingMethod',
      headers: {
        Accept: 'text/plain',
        'Content-Type': 'application/json',
        Authorization: 'Bearer ' + this.$cookies.get('2sote_Auth_Token'),
      },
    }
    try {
      await axios(config).then((response) => {
        console.log('FetchListShippingMethod', response)

        commit('SET_LIST_SHIPPING_METHOD', response.data.data)
      })
    } catch (err) {}
  },

  async FetchUserAddressList({ state, commit }) {
    console.log('FetchUserAddressList','FetchUserAddressList')
    var config = {
      method: 'GET',
      url: '/api/Account/UserAddressList',
      headers: {
        Accept: 'text/plain',
        'Content-Type': 'application/json',
        Authorization: 'Bearer ' + this.$cookies.get('2sote_Auth_Token'),
      },
    }
    try {
      await axios(config).then((response) => {
        console.log('FetchUserAddressList', response)
        commit('SET_USER_ADDRESS_LIST', response.data.data)
      })
    } catch (err) {}
  },
  async FetchAddressEdit({ state, commit }, addressDetail) {
    console.log('addressDetail', addressDetail)
    let data = JSON.stringify({
      state: 15,
      city: 168,
      address: addressDetail.address,
      name: addressDetail.name,
      mobile: addressDetail.mobile,
      id: addressDetail.id,
      plaque: '',
      unit: '',
      tel: '',
      postalCode: '',
      latlng: '',
    })
    var config = {
      method: 'POST',
      url: '/api/Account/AddressEdit',
      data: data,
      headers: {
        Accept: 'text/plain',
        'Content-Type': 'application/json',
        Authorization: 'Bearer ' + this.$cookies.get('2sote_Auth_Token'),
      },
    }
    try {
      await axios(config).then((response) => {
        console.log('FetchAddressEdit', response.data)
        commit('SET_MSG', response.data.msg.text)
        if (response.data.isSuccess == true) {
          commit('SET_EDIT_USER_ADDRESS_LIST', addressDetail)
        }
      })
    } catch (err) {}
  },
  async FetchAddressAdd({ state, commit }, addressDetail) {
    console.log('addressDetail', addressDetail)
    let data = JSON.stringify({
      state: 15,
      city: 168,
      address: addressDetail.address,
      name: addressDetail.name,
      mobile: addressDetail.mobile,
      plaque: '',
      unit: '',
      tel: '',
      postalCode: '',
      latlng: '',
    })
    var config = {
      method: 'POST',
      url: '/api/Account/AddressAdd',
      data: data,
      headers: {
        Accept: 'text/plain',
        'Content-Type': 'application/json',
        Authorization: 'Bearer ' + this.$cookies.get('2sote_Auth_Token'),
      },
    }
    try {
      await axios(config).then((response) => {
        console.log('FetchAddressAdd', response.data)
        commit('SET_MSG', response.data.msg.text)
        if (response.data.isSuccess == true) {
          console.log('trueeeeeeee')
          // commit('SET_ADD_USER_ADDRESS_LIST', addressDetail)
          // dispatch('checkout/FetchUserAddressList', '', { root: true })

          this.$store.dispatch('checkout/FetchUserAddressList')
        }
      })
    } catch (err) {}
  },

  async FetchFactorDtlShow({ state, commit }, FactorIdAfterLogin) {
    console.log('skdmksm')
    console.log(FactorIdAfterLogin)

    var config = {
      method: 'POST',
      url: '/api/Factor/FactorDtlShow',
      data: FactorIdAfterLogin,
      headers: {
        Accept: 'text/plain',
        'Content-Type': 'application/json',
        // Authorization: 'Bearer ' + this.$cookies.get('2sote_Auth_Token'),
      },
    }
    try {
      console.log('skdmksm2255555555')
      console.log(FactorIdAfterLogin)

      await axios(config).then((response) => {
        console.log('skdmksm222222')

        console.log(response)
        // if (response.status == 200) {
        commit('SET_USER_SHOP_CART', response.data.data)
        // }
      })
    } catch (err) {
      console.log(err)
    }
  },
}
