import ProductService from '@/services/ProductService.js'
import axios from 'axios'
export const state = () => ({
  FactorIdAfterLogin: '',
  UserShopCart: [],
  lengthShopCart:0,
  TotalPrice: 0,
  countProduct: 0,
  ShippingCalc: '',

  // count: 0,
  // showAddToCard: false,
})
export const getters = {
  GetFactorIdAfterLogin(state) {
    return state.FactorIdAfterLogin
  },
  GetUserShopCart(state) {
    return state.UserShopCart
  },
  GetShippingCalc(state) {
    return state.ShippingCalc
  },
  GetTotalPrice(state) {
    return state.TotalPrice
  },
  GetCountProduct(state) {
    return state.countProduct
  },
  GetlengthShopCart(state) {
    return state.lengthShopCart
  },
  // GetCount(state) {
  //   return state.count
  // },
  // GetShowAddToCard(state) {
  //   return state.showAddToCard
  // },
}
export const mutations = {
  SET_FACTOR_ID_AFTER_LOGIN(state, FactorIdAfterLogin) {
    state.FactorIdAfterLogin = FactorIdAfterLogin
  },
  SET_USER_SHOP_CART(state, shopCart) {
    state.UserShopCart = shopCart
    state.TotalPrice = 0
    state.lengthShopCart =shopCart.length
    for (let i = 0; i < shopCart.length; i++) {
      state.TotalPrice += shopCart[i].sumPrice
    }
  },
  SET_COUNT_PRODUCT(state, productId) {
    state.countProduct=0
    state.countProduct =  state.UserShopCart.find((product) => product.productID == productId)?.count

    //  console.log('productId',productId)
    //  state.UserShopCart.find(
    //    (product) => product.productID == productId
    // )?.count+1
  },
  SET_SHIPPING_CALC(state, ShippingCalc) {
    state.ShippingCalc = ShippingCalc
  },
  // DELETE_PRODUCT_AT_FACTOR(state, factorDtlId) {
  //   state.UserShopCart = state.UserShopCart.find((product) => (product.id !== factorDtlId))
  // },
  // SET_COUNT(state, data) {
  //   if (data == 0) {
  //     state.count = data
  //   } else {
  //     state.count += data
  //   }
  // },
  // SET_SHOWADDTOCARD(state, data) {
  //   state.showAddToCard = data
  // },
}
export const actions = {
  async FetchFactorIdAfterLogin({ state, commit }) {
    console.log('FetchFactorIdAfterLogin')
    var config = {
      method: 'GET',
      url: '/api/Factor/GetFactorIdAfterLogin',
      headers: {
        Accept: 'text/plain',
        'Content-Type': 'application/json',
        Authorization: 'Bearer ' + this.$cookies.get('2sote_Auth_Token'),
      },
    }
    try {
      await axios(config).then((response) => {
        console.log(response)
        if (response.status == 200 && response.status !== 401) {
          commit('SET_FACTOR_ID_AFTER_LOGIN', response.data.data)
        }
      })
    } catch (err) {}
  },
  async FetchFactorDtlAdd({ state, commit }, orderDetail) {
    var config = {
      method: 'POST',
      url: '/api/Factor/FactorDtlAdd',
      data: {
        factorId: state.FactorIdAfterLogin,
        productId: orderDetail.productId,
        qty: orderDetail.qty,
        updateCount: orderDetail.updateCount,
      },
      headers: {
        Accept: 'text/plain',
        'Content-Type': 'application/json',
        // Authorization: 'Bearer ' + this.$cookies.get('2sote_Auth_Token'),
      },
    }
    try {
      await axios(config).then((response) => {
        console.log(response)
        if (response.status == 200) {
          commit('SET_USER_SHOP_CART', response.data.data)
          commit('SET_COUNT_PRODUCT', orderDetail.productId)

          // localStorage.setItem(
          //   `product_${orderDetail.productId}`,
          //   JSON.stringify(1)
          // )

          if (
            localStorage.hasOwnProperty(`product_${orderDetail.productId}`) ==
            true
          ) {
            let productCount = JSON.parse(
              localStorage.getItem(`product_${orderDetail.productId}`)
            )
            console.log(productCount)
            // localStorage.removeItem(`product_${orderDetail.productId}`);

            localStorage.setItem(
              `product_${orderDetail.productId}`,
              JSON.stringify(productCount + orderDetail.qty)
            )
          } else {
            console.log('no exist')

            localStorage.setItem(
              `product_${orderDetail.productId}`,
              JSON.stringify(orderDetail.qty)
            )
          }

          l //ocalStorage.clear();
        }
      })
    } catch (err) {}
  },

  async FetchFactorDtlShow({ state, commit }, FactorIdAfterLogin) {
    console.log('GetFactorIdAfterLogin', FactorIdAfterLogin)

    // if(state.FactorIdAfterLogin = ''){
    //   console.log('nnnnnnnnnnnnnnnnnnnnnnnnnnnnnn')

    //  dispatch('FetchFactorIdAfterLogin')
    // }

    var config = {
      method: 'POST',
      url: '/api/Factor/FactorDtlShow',
      data: FactorIdAfterLogin,
      headers: {
        Accept: 'text/plain',
        'Content-Type': 'application/json',
        // Authorization: 'Bearer ' + this.$cookies.get('2sote_Auth_Token'),
      },
    }
    try {
      await axios(config).then((response) => {
        console.log('FetchFactorDtlShow', response.data.data)
        // if (response.status == 200) {
        commit('SET_USER_SHOP_CART', response.data.data)
        // }
      })
    } catch (err) {
      console.log(err)
    }
  },

  async FetchFactorDtlDelete({ state, commit }, factorDtlId) {
    console.log('factorDtlId', factorDtlId.id)
    console.log('productID', factorDtlId.productID)
    var config = {
      method: 'POST',
      url: '/api/Factor/FactorDtlDelete',
      data: {
        factorId: state.FactorIdAfterLogin,
        factorDtlId: factorDtlId.id,
      },
      headers: {
        Accept: 'text/plain',
        'Content-Type': 'application/json',
        // Authorization: 'Bearer ' + this.$cookies.get('2sote_Auth_Token'),
      },
    }
    try {
      await axios(config).then((response) => {
        console.log('FetchFactorDtlDelete', response)
        commit('SET_USER_SHOP_CART', response.data.data)
        localStorage.removeItem(`product_${factorDtlId.productID}`)
      })
    } catch (err) {}
  },

  async FetchShippingCalc({ state, commit }, orderDetail) {
    console.log('factorDtlId', factorDtlId)
    var config = {
      method: 'POST',
      url: '/api/Base/GetShippingCalc',
      data: {
        shippingMethodCode: orderDetail,
        addressId: orderDetail.factorDtlId,
        factorId: state.FactorIdAfterLogin,
      },
      headers: {
        Accept: 'text/plain',
        'Content-Type': 'application/json',
        // Authorization: 'Bearer ' + this.$cookies.get('2sote_Auth_Token'),
      },
    }
    try {
      await axios(config).then((response) => {
        console.log('FetchFactorDtlDelete', response)
        commit('SET_USER_SHOP_CART', response.data.data)
      })
    } catch (err) {}
  },

   AddToCard(productId, count, orderMin) {
      console.log('count', count)
      console.log('orderMin', orderMin)
      if (count == 0) {
        if (orderMin == 1) {
          count += orderMin
        } else if (orderMin !== 1) {
          count += orderMin
        }
      } else {
        if (count >= 1) {
          if (orderMin < 0) {
            count -= 1
          } else {
            count += 1
          }
        } else if (count < 1) {
          count += orderMin
        }
      }
      const orderDetail = {
        productId: productId,
        qty: orderMin,
        updateCount: false,
      }

      this.$store.dispatch('order/FetchFactorDtlAdd', orderDetail)
    },
  // showAddToCard({ state, commit }) {
  //   commit('SET_SHOWADDTOCARD', true)
  // },
  // hideAddToCard({ state, commit }) {
  //   commit('SET_SHOWADDTOCARD', false)
  // },
  // AddToCard({ state, commit }) {
  //   commit('SET_SHOWADDTOCARD', true)
  //   commit('SET_COUNT', 1)
  // },
  // removeToCard({ state, commit }) {
  //   if (state.count !== 0 && state.count !== 1) commit('SET_COUNT', -1)
  // },
  // removeAll({ state, commit }) {
  //   commit('SET_COUNT', 0)
  //   commit('SET_SHOWADDTOCARD', false)
  // },
}
