import ProductService from '@/services/ProductService.js'
export const state = () => ({
  product_groups: [],
  product_lists: [],
  list_Products_Group_by_Parnet: [],
  list_Products_Group_by_Parnet_cat: [],
  list_Special_Products: [],
  single_product: {},
})
export const getters = {
  GetProductGroups(state) {
    return state.product_groups
  },
  GetProductLists(state) {
    return state.product_lists
  },
  GetListProductsGroupbyParnet(state) {
    return state.list_Products_Group_by_Parnet
  },
  GetListProductsGroupbyParnetCat(state) {
    return state.list_Products_Group_by_Parnet_cat
  },
  GetListSpecialProducts(state) {
    return state.list_Special_Products
  },
  GetSingleProduct(state) {
    return state.single_product
  },
}
export const mutations = {
  SET_PRODUCT_GROUPS(state, ProductGroups) {
    state.product_groups = ProductGroups
  },
  SET_PRODUCT_LISTS(state, ProductLists) {
    state.product_lists = ProductLists
  },
  SET_LIST_PRODUCTS_GROUP_BY_PARENT(state, ListProductsGroupbyParnet) {
    state.list_Products_Group_by_Parnet = ListProductsGroupbyParnet
  },
  SET_LIST_PRODUCTS_GROUP_BY_PARENT_CAT(state, ListProductsGroupbyParnetCat) {
    state.list_Products_Group_by_Parnet_cat = ListProductsGroupbyParnetCat
  },
  SET_LIST_SPECIAL_PRODUCTS(state, listSpecialProducts) {
    state.list_Special_Products = listSpecialProducts
  },
  GET_SINGLE_PRODUCT(state, singleProduct) {
    state.single_product = singleProduct
  },
}
export const actions = {
  async fetchProductGroups({ state, commit }) {
    if (state.product_groups.length) return
    try {
      await ProductService.getProductGroups().then((response) => {
        console.log(response)
        commit('SET_PRODUCT_GROUPS', response.data.data)
      })
    } catch (err) {
      console.log(err)
    }
  },
  async fetchProductLists({ state, commit }, groupID) {
    try {
      await ProductService.getProductLists(groupID).then((response) => {
        console.log(response)
        commit('SET_PRODUCT_LISTS', response.data.data.product)
      })
    } catch (err) {
      console.log(err)
    }
  },
  async fetchListProductsGroupbyParnet({ state, commit }, parentId) {
    const FormData = require('form-data')
    let data = new FormData()
    data.append('parentId', parentId)
    // if (state.list_Products_Group_by_Parnet.length) return
    try {
      if (parentId == 0) {
        await ProductService.getListProductsGroupbyParnet(data).then(
          (response) => {
            // console.log(parentId.parentId + 'skdlamlakw')
            console.log(response)
            commit('SET_LIST_PRODUCTS_GROUP_BY_PARENT', response.data.data)
          }
        )
      } else {
        await ProductService.getListProductsGroupbyParnet(data).then(
          (response) => {
            console.log(parentId.parentId + '1111')
            console.log(response)
            commit('SET_LIST_PRODUCTS_GROUP_BY_PARENT_CAT', response.data.data)
          }
        )
      }
    } catch (err) {
      console.log(err)
    }
  },

  async fetchListSpecialProducts({ state, commit }) {
    if (state.list_Special_Products.length) return
    try {
      await ProductService.getListSpecialProducts().then((response) => {
        console.log(response)
        commit('SET_LIST_SPECIAL_PRODUCTS', response.data.data.product)
      })
    } catch (err) {
      console.log(err)
    }
  },

  async addSingleProduct({ state, commit }, productId) {
    try {
      await ProductService.getSingleProduct(productId).then((response) => {
        console.log(response + '555555555555555555')
        commit('GET_SINGLE_PRODUCT', response.data.data)
      })
    } catch (err) {
      console.log(err)
    }
  },
}
